-- vl[`XNvgAw肳ȂɎgpXNvgłB

-- O[oϐ
-- XNvg̃RpCQ[ɘjĕςȂĺAŏɎ擾B

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()

require('com_util.lua')
require('com_default_attack.lua')
require('com_default_goto_capital.lua')
require('com_default_unload.lua')
require('com_default_occupy.lua')
require('com_default_ride.lua')
require('com_default_supply_me.lua')
require('com_default_save.lua')
require('com_default_goto_attack.lua')
require('com_default_goto_load.lua')
require('com_default_create.lua')

-----------------------------------------------------------------------------
local debug_log_out=false
local function debug_log(str)
	if debug_log_out then
		print_log(str)
	end
end
-----------------------------------------------------------------------------
-- Pjbg삷B
local function action_unit(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]
	local movex, movey, targetx, targety, gun_index
	local supplyx, supplyy	-- ⋋ꍇ̖ړIW

	-- v⋋̔fB⋋s͑̍sƓɉ\iڎjB
	local supply_flag = com_default_supply_me.get_need_supply(unit_state, unit_info)
	if supply_flag ~= 0 then
		supplyx, supplyy = com_default_supply_me.action_unit_supply_me(ground_layer, my_side, serial, supply_flag)
	end

	-- ڐ`FbN
	if com_util.table_getn(unit_state['load']) == 0 then
		-- ڂĂȂꍇB
		if supplyx == nil or (unit_state['x'] == supplyx and unit_state['y'] == supplyy) then
			-- ⋋̕KvA݈ʒuɂƂǂ܂Ε⋋łꍇB
			-- ԐڍU
			local movex, movey, targetx, targety, gun_index =
				com_default_attack.action_unit_nomove_attack(ground_layer, my_side, serial)
			if movex ~= nil then
				debug_log("A "..movex..","..movey)
				ks_set_attack(my_side, serial, movex, movey, gun_index, targetx, targety, true)
				return
			end
		end
		if unit_info['occupy'] then
			-- ̉\jbg̏ꍇA̍si^[Ő̉\Ȏ{݂ꍇjB
			local movex, movey = com_default_occupy.action_unit_occupy_direct(ground_layer, my_side, serial)
			if movex ~= nil then
				debug_log("B "..movex..","..movey)
				-- ړB
				ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
				return
			end
		end
		if supplyx == nil then
			-- ⋋̕Kvꍇ̂݁B
			-- ڍU
			local movex, movey, targetx, targety, gun_index =
				com_default_attack.action_unit_move_attack(ground_layer, my_side, serial)
			if movex ~= nil then
				debug_log("C "..movex..","..movey)
				ks_set_attack(my_side, serial, movex, movey, gun_index, targetx, targety, true)
				return
			end
		end
		if unit_info['occupy'] then
			-- ̉\jbg̏ꍇA̍sB
			local movex, movey = com_default_occupy.action_unit_occupy(ground_layer, my_side, serial)
			if movex ~= nil then
				debug_log("D "..movex..","..movey)
				-- ړB
				ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
				return
			end
		end
		if unit_info['loadmax'] > 0 then
			-- ډ\jbgڂĂȂꍇAډ\n_ɈړB
			local movex, movey = com_default_goto_load.action_unit_goto_load(ground_layer, my_side, serial)
			if movex ~= nil then
				debug_log("E "..movex..","..movey)
				-- ړB
				ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
				return
			end
		end
	else
		-- ~
		local movex, movey, unload_tbl = com_default_unload.action_unit_unload(ground_layer, my_side, serial)
		if movex ~= nil then
			if unload_tbl ~= nil then
				debug_log("F "..movex..","..movey)
				-- ړč~ԁB
				ks_set_unload(my_side, serial, movex, movey, unload_tbl, true)
			else
				debug_log("G "..movex..","..movey)
				-- ړB
				ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
			end
			return
		end
	end

	-- ⋋̂߂̈ړB
	if supplyx ~= nil then
		debug_log("H "..supplyx..","..supplyy)
		-- ړB
		ks_set_attack(my_side, serial, supplyx, supplyy, -1, 0, 0, true)
		return
	end

	-- ԁîǂ̍słȂꍇjB
	local movex, movey =
		com_default_ride.action_unit_ride(ground_layer, my_side, serial)
	if movex ~= nil then
		debug_log("I "..movex..","..movey)
		-- ړďԁB
		ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
		return
	end

	-- hqsB
	local movex, movey =
		com_default_save.action_unit_save(ground_layer, my_side, serial)
	if movex ~= nil then
		debug_log("J "..movex..","..movey)
		-- ړB
		ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
		return
	end

	-- GsiB
	local movex,movey = com_default_goto_capital.action_unit_goto_enemy_capital(ground_layer, my_side, serial)
	if movex ~= nil then
		debug_log("K "..movex..","..movey)
		ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
		return
	end

	-- UΏۂ߂ĈړB
	local movex,movey = com_default_goto_attack.action_unit_goto_attack(my_side, serial)
	if movex ~= nil then
		debug_log("L "..movex..","..movey)
		ks_set_attack(my_side, serial, movex, movey, -1, 0, 0, true)
		return
	end

	-- ɖ{ɉ邱ƂAƂ肠⋋B
	local supply_sensitive_flag = com_default_supply_me.get_need_supply_sensitive(unit_state, unit_info)
	if supply_flag ~= 0 then
		supplyx, supplyy = com_default_supply_me.action_unit_supply_me(ground_layer, my_side, serial, supply_sensitive_flag)
		-- ⋋̂߂̈ړB
		if supplyx ~= nil then
			-- ړB
			ks_set_attack(my_side, serial, supplyx, supplyy, -1, 0, 0, true)
			debug_log("M "..supplyx..","..supplyy)
			return
		end
	end
end
-----------------------------------------------------------------------------
-- wc̃jbgS삷B
local function action_units()
	local ground_layer = ks_get_ground_layer()
	local my_side = ks_get_my_side()
	local all_unit = ks_get_unit_allside()
	local all_myunit = all_unit[my_side]		-- wc̑Sjbg

	-- ԐڍUjbgɓ߂Ƀ\[gB
	table.sort(all_myunit,
		function(s1, s2)
			local unit_state1 = ks_get_unit_status(my_side, s1)
			local unit_state2 = ks_get_unit_status(my_side, s2)
			local unit_info1 = unit_info_tbl[unit_state1['id']]
			local unit_info2 = unit_info_tbl[unit_state2['id']]
			local minr1 = unit_info1['guninfo'][0]['minrange']
			local minr2 = unit_info2['guninfo'][0]['minrange']
			-- ǂ炩ԐڍUjbg̎B
			if minr1 > 1 or minr2 > 1 then
				-- PԖڂQԖڂ傫trueԂB
				return minr1 > minr2
			end
			-- ǂԐڍUjbgłȂꍇAډ\jbgɂB
			if unit_info2['loadmax'] > 0 then
				return not (unit_info1['loadmax'] > 0)
			else
				return false
			end
		end
	)

	-- table.foreach()yieldłȂ߁AforŎsKvB
	local seriallist = {}
	local count = 1
	table.foreach(all_myunit,
		function(n, serial)
			seriallist[count] = serial
			count = count + 1
		end
	)

	for i=1,count-1,1 do
		local serial = seriallist[i]
		local unit_state = ks_get_unit_status(my_side, serial)
		local unit_info = unit_info_tbl[unit_state['id']]
		if unit_state['x'] ~= -1 and not unit_state['actioned'] then
			action_unit(ground_layer, my_side, serial)
		end
		-- ̍sȂꍇAn`擾ȂB
		if unit_info['occupy'] then
			ground_layer = ks_get_ground_layer()
		end
		ks_yield()
	end

end
-----------------------------------------------------------------------------
-- wc̃tF[YɂPĂ΂B
function ks_on_side_operation()
	-- B
	com_default_attack.init_on_phasestart()
	com_default_goto_capital.init_on_phasestart()
	com_default_occupy.init_on_phasestart()
	com_default_unload.init_on_phasestart()
	com_default_save.init_on_phasestart()
	com_default_goto_attack.init_on_phasestart()
	com_default_create.init_on_phasestart()
	-- B
	action_units()

	com_default_create.create_units()
end
-----------------------------------------------------------------------------
--ks_set_all_warning(true)
