-- GUɍsB

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local unit_atk_tbl = com_cached_db.get_unit_attack_table()

require('com_util.lua')

local side_info_tbl

-----------------------------------------------------------------------------
-- (x,y)ɋꍇɍU\ȃjbgւ̍U͂̍v߂B
local function find_target(x, y, unit_state, friendly_tbl)
	local minr=1000
	local maxr=0
	local unit_info = unit_info_tbl[unit_state['id']]
	for gun=0,GUN_MAX-1,1 do
		if minr > unit_info['guninfo'][gun]['minrange'] then
			minr = unit_info['guninfo'][gun]['minrange']
		end
		if maxr < unit_info['guninfo'][gun]['maxrange'] then
			maxr = unit_info['guninfo'][gun]['maxrange']
		end
	end

	local maxp=0
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x, y, minr, maxr);
	local i = 1
	while tbl_x[i] ~= nil do
		target_unit = ks_get_unit_status_on(tbl_x[i], tbl_y[i])
		if target_unit ~= nil then
			if friendly_tbl[target_unit['side']] <= 0 then
				local p = 0
				for gun=0,GUN_MAX-1,1 do
					-- ڍU܂͗אڂȂł̊ԐڍUΏۂƂB
					if unit_info['guninfo'][gun]['maxrange'] == 1 or i > 6 then
						p = p + unit_atk_tbl[unit_state['id']][gun][target_unit['id']] * unit_state['life']
						p = p - unit_atk_tbl[target_unit['id']][gun][unit_state['id']] * target_unit['life'] *2/3
					end
				end
				if maxp < p then
					maxp = p
				end
			end
		end
		i = i + 1
	end
	return maxp
end
-----------------------------------------------------------------------------
-- (x,y)ɍł߂U\jbgTB͎̈ړRXgŋ߂B
local function find_target_location(x, y, unit_state, cost, friendly_tbl)
	local movable_layer = ks_get_distance_layer(x, y, unit_state['id'], cost)
	local maxatkp=1
	local maxp=0
	local px, py

	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			local atkp = find_target(x, y, unit_state, friendly_tbl)
			if maxatkp <= atkp and maxp < p then
				maxatkp = atkp
				maxp = p
				px = x
				py = y
			end
		end
	)
	return px, py
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_goto_attack = {}

com_default_goto_attack['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end
-----------------------------------------------------------------------------
-- U\ȓGTAڎwB
com_default_goto_attack['action_unit_goto_attack'] = function(my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	-- ͈͂B
	local cost = unit_state['fuel']/3
	if cost < unit_info['movemax']*2 then
		cost = unit_state['fuel']
	end

	-- ߂̍UΏۂTB
	local px, py = find_target_location(unit_state['x'], unit_state['y'], unit_state, cost, side_info_tbl[my_side]['friendly'])
	if px == nil then
		return
	end

	-- ړ\͈͂𒲂ׂB
	local movex, movey = com_util.get_way_xy(px, py, my_side, serial, cost)

	return movex, movey
end
