-- ȕ⋋̎vl[`B

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local ground_tbl = com_cached_db.get_ground_table()
local supply_unit_neighbor_tbl, supply_unit_loading_tbl = com_cached_db.get_supply_unit_table()
local map_width,map_height = ks_get_mapsize()			-- }bvTCY

local side_info_tbl

-- ⋋KvƔfcʂ̊B
local need_supply_life = 0.4
local need_supply_fuel = 0.3
local need_supply_gun = 0.2

-- ɂ邱ƂA⋋KvƔfcʂ̊B
local need_supply_sensitive_life = 1.0
local need_supply_sensitive_fuel = 0.7
local need_supply_sensitive_gun = 0.8

-----------------------------------------------------------------------------
-- (x,y)ɍł߂⋋\n`TB͎̈ړRXgŋ߂B
local function find_supply_ground_location(ground_layer, my_side, x, y, unit_state, cost)
	local movable_layer = ks_get_distance_layer(x, y, unit_state['id'], cost)
	local maxp=0
	local px, py

	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			local gnd_tbl = ground_layer[i]
			if gnd_tbl['is_building'] and gnd_tbl['owner'] == my_side and
				ks_bit_and(ground_tbl[unit_state['id']][gnd_tbl['id']], GROUND_CAN_SUPPLY) ~= 0 then
				-- ȊO̖jbĝȂ΁AƂ肠B
				local unit_state2
				if x ~= unit_state['x'] or y ~= unit_state['y'] then
					unit_state2 = ks_get_unit_status_on(x, y)
				end
				if unit_state2 == nil or unit_state2['side'] ~= my_side then
					if maxp < p then
						maxp = p
						px = x
						py = y
					end
				end
			end
		end
	)
	return px,py
end
-----------------------------------------------------------------------------
-- (x,y)̎͂unit_stateɕ⋋\ȃjbg邩ǂׂB
-- supply_flag ͕Kvȕ⋋B߂l͐^UlB
local function exists_neighbor_supply_unit(x, y, unit_state, supply_flag)
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x, y, 1, 1)
	local ret = false

	table.foreach(tbl_x,
		function(i, v)
			local unit_state2 = ks_get_unit_status_on(tbl_x[i], tbl_y[i])
			if unit_state2 ~= nil and unit_state2['side'] == unit_state['side'] then
				if ks_bit_and(supply_unit_neighbor_tbl[unit_state2['id']][unit_state['id']], supply_flag) ~= 0 then
					ret = true
				end
			end
		end
	)
	return ret
end
-----------------------------------------------------------------------------
-- (x,y)ɍł߂⋋\jbgTB͎̈ړRXgŋ߂B
-- supply_flag ͕Kvȕ⋋B
local function find_supply_unit_location(ground_layer, my_side, x, y, unit_state, supply_flag, cost)
	local movable_layer = ks_get_distance_layer(x, y, unit_state['id'], cost)
	local maxp=0
	local px, py
	table.remove(movable_layer, y*map_width + x) -- ݈ʒuׂ͒Ȃi݈ʒu瓮ȂĂǂ͏ʂŌ肷jB

	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			local unit_state2 = ks_get_unit_status_on(x, y)
			if unit_state2 ~= nil and unit_state2['side'] == unit_state['side'] then
				-- ڕ⋋jbg邩B
				if ks_bit_and(supply_unit_loading_tbl[unit_state2['id']][unit_state['id']], supply_flag) ~= 0 then
					if maxp < p then
						maxp = p
						px = x
						py = y
					end
				end
			else
				-- אڕ⋋jbg邩B
				if exists_neighbor_supply_unit(x, y, unit_state, supply_flag) then
					if maxp < p then
						maxp = p
						px = x
						py = y
					end
				end
			end
		end
	)
	return px,py
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_supply_me = {}

com_default_supply_me['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end

com_default_supply_me['set_need_supply_life'] = function(v) need_supply_life = v end
com_default_supply_me['set_need_supply_fuel'] = function(v) need_supply_fuel = v end
com_default_supply_me['set_need_supply_gun'] = function(v) need_supply_gun = v end
com_default_supply_me['set_need_supply_sensitive_life'] = function(v) need_supply_sensitive_life = v end
com_default_supply_me['set_need_supply_sensitive_fuel'] = function(v) need_supply_sensitive_fuel = v end
com_default_supply_me['set_need_supply_sensitive_gun'] = function(v) need_supply_sensitive_gun = v end
-----------------------------------------------------------------------------
-- unit_state ɕKvȕ⋋tO擾B
com_default_supply_me['get_need_supply'] = function(unit_state, unit_info)
	local supply_flag = 0
	if unit_state['life'] < 100*need_supply_life then
		supply_flag = ks_bit_or(supply_flag, SUPPLY_LIFE)
	end
	if unit_state['fuel'] < unit_info['fuelmax']*need_supply_fuel then
		supply_flag = ks_bit_or(supply_flag, SUPPLY_FUEL)
	end
	for gun=0, GUN_MAX-1, 1 do
		if unit_state['gun'][gun] < unit_info['guninfo'][gun]['gunmax']*need_supply_gun then
			supply_flag = ks_bit_or(supply_flag, SUPPLY_GUN)
		end
	end
	return supply_flag
end
-----------------------------------------------------------------------------
-- unit_state ɕKvȕ⋋tOɕqɎ擾B
com_default_supply_me['get_need_supply_sensitive'] = function(unit_state, unit_info)
	local supply_flag = 0
	if unit_state['life'] < 100*need_supply_sensitive_life then
		supply_flag = ks_bit_or(supply_flag, SUPPLY_LIFE)
	end
	if unit_state['fuel'] < unit_info['fuelmax']*need_supply_sensitive_fuel then
		supply_flag = ks_bit_or(supply_flag, SUPPLY_FUEL)
	end
	for gun=0, GUN_MAX-1, 1 do
		if unit_state['gun'][gun] < unit_info['guninfo'][gun]['gunmax']*need_supply_sensitive_gun then
			supply_flag = ks_bit_or(supply_flag, SUPPLY_GUN)
		end
	end
	return supply_flag
end
-----------------------------------------------------------------------------
-- ⋋\n`^jbgTAڎwB
com_default_supply_me['action_unit_supply_me'] = function(ground_layer, my_side, serial, supply_flag)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	-- ͈͂B
	local cost = unit_state['fuel']/3
	if cost < unit_info['movemax']*2 then
		cost = unit_state['fuel']
	end

	-- ߂̕⋋\n`TB
	local px, py = find_supply_ground_location(ground_layer, my_side, unit_state['x'], unit_state['y'], unit_state, cost)
	if px ~= nil then
		-- Ȓ̈ړ\͈͂𒲂ׂB
		local movex, movey = com_util.get_way_xy(px, py, my_side, serial, unit_state['fuel'])
		return movex, movey
	end

	-- ݕ⋋\jbgׂ̗ȂA݈ʒuԂB
	if exists_neighbor_supply_unit(unit_state['x'], unit_state['y'], unit_state, supply_flag) then
		return unit_state['x'], unit_state['y']
	end

	-- ߂̕⋋\jbgTB
	local px, py = find_supply_unit_location(ground_layer, my_side, unit_state['x'], unit_state['y'], unit_state, supply_flag, cost)
	if px ~= nil then
		-- Ȓ̈ړ\͈͂𒲂ׂB
		local movex, movey = com_util.get_way_xy(px, py, my_side, serial, unit_state['fuel'])
		return movex, movey
	end
end
