require('simple_menu.lua')

local image_test
local message_index
local side_info

local function my_init()
	-- 摜̃[hB
	if image_test == nil then
		image_test = ks_window_img_load("200508_1.png")
	end
	-- bZ[Ẅ̐ݒB
	if message_index == nil then
		message_index = ks_window_msg_view(-1, 128, 8, 632, 192)
		ks_window_msg_setdraw(message_index, ks_window_rgb(128, 120, 80), 64, ks_window_rgb(255, 255, 255), 18)
	end
	-- wcB
	side_info = ks_get_side()
end

local function draw_face(x, y)
	ks_window_img_copy(IMAGE_WINDOW, x, y, image_test, 0, 0, 100, 112)
end

-- simple_menu.lua ̃j[`悷B
local function draw_menu(menu, selected_index)
	local x, y = simple_menu.get_xy(menu)
	local menuw, menuh = simple_menu.get_itemsize(menu)
	local items = simple_menu.get_items(menu)
	local count=0
	table.foreach(items,
		function(n, itemname)
			local py = y + count*menuh
			local color
			if count == selected_index then
				color = ks_window_rgb(128, 128, 255)
			else
				color = ks_window_rgb(255, 255, 255)
			end
			ks_window_rectangle(x, py, x+menuw, py+menuh, ks_window_rgb(0, 0, 0), color)
			ks_window_str(x+2, py+2, itemname, ks_window_rgb(0, 0, 0))
			count = count+1
		end
	)
end

-- side1  side2 ̑݊֌Wݒ肷B
local function set_friendly(side1, side2, friendly)
	ks_side_relation_set_friendly(side1, side2, 1)
	ks_side_relation_set_friendly(side2, side1, 1)
end


function ks_on_newgame()
	my_init()
	-- Ƃ肠wcB
	if ks_get_my_side() ~= 0 then
		return
	end
	ks_window_show("ׂ")
	ks_window_size_set(640, 320)
	ks_window_msg_out(message_index, "ǂ̐wcƓт܂H")
	ks_window_msg_out(message_index, "ȂAI΂Ȃwc͂ꂼœт܂B")
	ks_yield()
	-- wcIj[쐬B
	local menu=simple_menu.create(128, 200, 200, 24)
	for i=1,3,1 do
		simple_menu.add_item(menu, side_info[i]['name'])
	end
	-- j[IB
	local selected_index
	while not ks_window_mouse_left_downed() or selected_index==nil do
		-- |Cgꂽj[擾B
		local mousex, mousey = ks_window_mouse_xy()
		selected_index = simple_menu.get_selected_index(menu, mousex, mousey)
		ks_window_clear(ks_window_rgb(0, 0, 0))
		draw_face(8, 8)
		ks_window_str(8, 128, "Qd@GU", ks_window_rgb(255, 255, 255))
		draw_menu(menu, selected_index)
		ks_yield()
	end
	-- I΂ꂽj[擾B
	local mousex, mousey = ks_window_mouse_xy()
	selected_index = simple_menu.get_selected_index(menu, mousex, mousey)
	local other_indice = {1,2,3}
	table.remove(other_indice, selected_index+1)
	-- B
	set_friendly(0, selected_index+1, 1)
	set_friendly(other_indice[1], other_indice[2], 1)
	-- ̕񍐁B
	ks_window_clear(ks_window_rgb(0, 0, 0))
	draw_face(8, 8)
	ks_window_str(8, 128, "Qd@GU", ks_window_rgb(255, 255, 255))
	ks_window_msg_clear(message_index)
	ks_window_msg_out(message_index, "ccł́A䂪wcu"..side_info[0]['name'].."v")
	ks_window_msg_out(message_index, "u"..side_info[selected_index+1]['name'].."vƓт܂B")
	ks_window_msg_out(message_index, "u"..side_info[other_indice[1]]['name'].."vƁu"..side_info[other_indice[2]]['name'].."v")
	ks_window_msg_out(message_index, "΍Rēт܂B")
	while not ks_window_mouse_left_downed() do
		ks_yield()
	end
	ks_window_hide()
end

function ks_on_phasestart()
	my_init()
	if ks_get_my_side() == 0 then
		gameinfo = ks_get_game_information()
		-- Q^[ڂ̏B
		if gameinfo['turn'] == 1 then
			ks_window_show("ׂƂQ")
			ks_window_size_set(640, 320)
			ks_yield()
			draw_face(8, 8)
			ks_window_str(8, 128, "QdGU", ks_window_rgb(255, 255, 255))
			ks_window_msg_clear(message_index)
			ks_window_msg_out(message_index, "ɈӖ͂܂B`eXgłB")
			ks_yield()
			local t_old = ks_window_gettime()
			while not ks_window_mouse_left_downed() do
				local t = ks_window_gettime() - t_old
				local x = t / 50 - 32
				if x > 640+64 then
					t_old = ks_window_gettime()
				end
				ks_window_clear(ks_window_rgb(0, 0, 0))
				draw_face(8, 8)
				ks_window_str(8, 128, "Qd@GU", ks_window_rgb(255, 255, 255))
				ks_window_boxfill(x, 64, x+32, 128, ks_window_rgb(0, 255, 0), 128)
				ks_window_framerect(x+16, 80, x+64, 144, ks_window_rgb(255, 0, 0), 128)
				ks_window_boxfill(x, 160, x+32, 192, ks_window_rgb(0, 255, 0), 256)
				ks_window_framerect(x, 192, x+32, 240, ks_window_rgb(255, 0, 0), 256)
				ks_window_img_copy_colorkey_alpha(IMAGE_WINDOW, x+8, 4, image_test, 0, 0, 100, 128, 0, 128)
				-- Ƒ҂B
				while ks_window_gettime() - t < 50 do
				end
				ks_yield()
			end
			ks_window_clear(ks_window_rgb(0, 0, 0))
			draw_face(8, 8)
--			ks_window_str(8, 128, "Qd@GU", ks_window_rgb(255, 255, 255))
			ks_window_msg_clear(message_index)
			ks_window_msg_out(message_index, "炵܂Bł͈Ȍ͏oĂ܂B")
			while not ks_window_mouse_left_downed() do
				ks_yield()
			end
			ks_window_hide()
		end
	end
end
