-- Uvl[`
-- ͂ɍUłGAőPU߂B

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local unit_atk_tbl = com_cached_db.get_unit_attack_table()

local map_width,map_height = ks_get_mapsize()			-- }bvTCY

-- wc̃jbg̃_[W̕]B
-- Gjbgւ̕]ɑ΂鑊Ε]Ȃ̂ŁA0.5`2.0𐄏B
local fear_my_damage = 1.3

-- ̉\jbg̓_[W]B
local evel_my_damage_occupy = 1.3
local evel_enemy_damage_occupy = 1.2

-- wcBtF[Y擾KvB
local side_info_tbl = nil

-----------------------------------------------------------------------------
-- Usꍇ̕]_߂B
local function get_attack_result(ground_layer, my_side, serial, x1, y1, gun_index, x2, y2)
	local damage_tbl = ks_set_attack(my_side, serial, x1, y1, gun_index, x2, y2, false)
	if damage_tbl == nil then
		return nil
	end

	local friendly_tbl = side_info_tbl[my_side]['friendly'];
	local result = 0

	table.foreach(damage_tbl,
		function(xy, dmg)
			local x,y = ks_index2xy(xy)
			local unit_state
			if x == x1 and y == y1 then
				-- g̏
				unit_state = ks_get_unit_status(my_side, serial)
			else
				-- gȊȌ
				unit_state = ks_get_unit_status_on(x, y)
			end
			local unit_info = unit_info_tbl[unit_state['id']]
			local side = unit_state['side']
			if side ~= my_side and friendly_tbl[side] <= 0 then
				-- Gւ̃_[W
				result = result + dmg * com_util.eval_unit_value(unit_info)
				-- ̉\jbg̏ꍇ
				if unit_info['occupy'] then
					result = result * evel_enemy_damage_occupy 
					-- R{݂̏ɐ̃jbgAXɕ]グB
					if ground_layer[xy]['owner'] == my_side then
						result = result * 2;
						-- ꂪsł΍XɏグB
						if ground_layer[xy]['is_capital'] then
							result = result * 2;
						end
					end
				end
			else
				-- ւ̃_[W
				result = result - dmg * com_util.eval_unit_value(unit_info) * fear_my_damage
				-- ̉\jbg̏ꍇ
				if unit_info['occupy'] then
					result = result * evel_my_damage_occupy 
				end
			end
		end
	)
	return result
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_attack = {}

com_default_attack['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end

com_default_attack['set_fear_my_damage'] = function(v) fear_my_damage = v end
com_default_attack['set_evel_my_damage_occupy'] = function(v) evel_my_damage_occupy = v end
com_default_attack['set_evel_enemy_damage_occupy'] = function(v) evel_enemy_damage_occupy = v end
-----------------------------------------------------------------------------
-- ړčUł郆jbgTB
com_default_attack['action_unit_move_attack'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	local movable_layer = ks_get_movable_layer(my_side, serial)

	local movex, movey, targetx, targety, gun_index, maxp

	maxp = 0
	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			-- אڍWɂĒB
			local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x, y, 1, 1)
			table.foreach(tbl_x,
				function(i, v)
					if ks_get_unit_exists(tbl_x[i], tbl_y[i]) then
						for gun=0,GUN_MAX-1,1 do
							if unit_state['gun'][gun] > 0 then
								p = get_attack_result(ground_layer, my_side, serial, x, y, gun, tbl_x[i], tbl_y[i])
								if p ~= nil and maxp < p then
									maxp = p
									movex = x
									movey = y
									targetx = tbl_x[i]
									targety = tbl_y[i]
									gun_index = gun
								end
							end
						end
					end
				end
			)
		end
	)
	return movex, movey, targetx, targety, gun_index
end
-----------------------------------------------------------------------------
-- ԐڍUłꏊTB
com_default_attack['action_unit_nomove_attack'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	local movex, movey, targetx, targety, gun_index, maxp

	maxp = 0
	for gun=0,GUN_MAX-1,1 do
		local guninfo = unit_info['guninfo'][gun]
		-- ԐڍUΊ̂ݑΏ
		if unit_state['gun'][gun] > 0 and guninfo['maxrange'] > 1 then
			local tbl_x,tbl_y = ks_get_neighbor_xy_layer(unit_state['x'], unit_state['y'], guninfo['minrange'], guninfo['maxrange'])
			table.foreach(tbl_x,
				function(i, v)
					local p = get_attack_result(ground_layer, my_side, serial, unit_state['x'], unit_state['y'], gun, tbl_x[i], tbl_y[i])
					if p ~= nil and maxp < p then
						maxp = p
						movex = unit_state['x']
						movey = unit_state['y']
						targetx = tbl_x[i]
						targety = tbl_y[i]
						gun_index = gun
					end
				end
			)
		end
	end
	return movex, movey, targetx, targety, gun_index
end
-----------------------------------------------------------------------------
