-- Yvl[`B
-- Y{݂̋߂ɋGjbg𐔂AGjbgɑ΂U͂̍jbg
-- D悵ĐYB

-- ڍUƊԐڍU̕]B0.0 ` 1.0 ̊ԂŎw肷邱Ƃ𐄏B
local eval_of_direct_attack = 1.0
local eval_of_indirect_attack = 0.4

-- ڍUjbgƊԐڍUjbg̈ړ͂̕]B0.0`0.5 ̊ԂŎw肷邱Ƃ𐄏B
local eval_of_direct_move = 0.3
local eval_of_indirect_move = 0.1
-- E̕]B
local eval_of_visibility = 0.3

-- Y{݂̎͂𒲍鎞̔aB
local distance_from_factory = 12

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local unit_atk_tbl = com_cached_db.get_unit_attack_table()
local map_width,map_height = ks_get_mapsize()	-- }bvTCY

require('com_util.lua')

local side_info_tbl

-----------------------------------------------------------------------------
-- (cx,cy)ɍł߂̉\n`TBunit_id̈ړRXgŋ߂B
local function find_occupy_location(ground_layer, my_side, cx, cy, unit_id, cost)
	local movable_layer = ks_get_distance_layer(cx, cy, unit_id, cost)
	local maxp=0
	local px, py

	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			local gnd_tbl = ground_layer[y*map_width + x]
			if gnd_tbl['is_building'] and gnd_tbl['owner'] ~= my_side and
				(gnd_tbl['owner'] == -1 or side_info_tbl[my_side]['friendly'][gnd_tbl['owner']] <= 0) then
				maxp = p
				px = x
				py = y
			end
		end
	)
	return px,py
end
-----------------------------------------------------------------------------
-- jbg aid  tid ɑ΂U͂]B
-- ԐڍȔꍇA˒ĒڍỦ{ɕ]B
-- Ԑڂłő˒RxȂ璼ڍU]ႭȂB
local function eval_unit_atk(aid,tid)
	-- ̃jbg̍U̓e[u
	local unitinfo = unit_info_tbl[aid]
	local val = 0
	-- SẲΊ]B
	table.foreach(unitinfo['guninfo'],
		-- gun:ΊCfbNX  guninfo:ΊB
		function(gun,guninfo)
			minr = guninfo['minrange']
			maxr = guninfo['maxrange']
			atk = guninfo['attack'][tid]
			if minr == 1 then
				-- ڍU̕]Bő˒ŕ]B
				val = val + atk*maxr*eval_of_direct_attack
			else
				-- ԐڍU̕]Bő|ŏ˒ŕ]B
				val = val + (atk*maxr - atk*minr)*eval_of_indirect_attack
			end
		end
	)
	return val
end
-----------------------------------------------------------------------------
-- ԐڍUjbgH
local function is_indirect_unit(uid)
	for gun=0,GUN_MAX-1,1 do
		if unit_info_tbl[uid]['guninfo'][gun]['minrange'] > 1 then
			return true
		end
	end
	return false
end
-----------------------------------------------------------------------------
-- ڃjbg̕]B͂ɋ铋ډ\jbg̐ԂB
local function eval_load_unit(uid, load_sum_tbl)
	local v = 0
	table.foreach(load_sum_tbl,
		function(uid2, count)
			if unit_info_tbl[uid]['loadable'][uid2] then
				v = v + 1
			end
		end
	)
	return v
end
-----------------------------------------------------------------------------
-- (x,y)ɂ鐶Y\jbg]e[u쐬B
local function get_create_need_table_on(x, y, my_side, friendly_tbl, ground_layer, occupy_unit_id, tekisaku)
	-- Y\jbg擾B
	local cand_tbl = ks_get_creatable_unit_on(x,y,my_side)
	if cand_tbl == nil or table.getn(cand_tbl) == 0 then
		return nil
	end
	--print_log("x,y:",x,y)

	-- Y_̎͂ɁẢ\jbgčs̉\{݂邩ǂׂB
	-- ł͂邩ǂŁAW߂Kv͖B
	if occupy_unit_id ~= nil then
		local occupy_x, occupy_y = find_occupy_location(ground_layer, my_side, x, y, occupy_unit_id, distance_from_factory)
	end

	local atk_sum_tbl = {}	-- ͓Gւ̍U͏Wve[u
	local dmg_sum_tbl = {}	-- ͓G̃_[WWve[u
	local load_sum_tbl = {}	-- ͂ɂ鎩ڂ邱Ƃł郆jbg̐e[u
	local exist_tbl = {}	-- Ɏ͂ɂ閡jbge[u
	local need_on_tbl = {}	-- v]Wve[u

	-- (x,y)n_̃jbgve[u쐬EB
	table.foreach(unit_info_tbl,
		function (k,v)
			need_on_tbl[k] = 0
			atk_sum_tbl[k] = 0
			dmg_sum_tbl[k] = 0
			load_sum_tbl[k] = 0
			exist_tbl[k] = 0
		end
	)
	-- ̍WoĂB
	need_on_tbl['x'] = x
	need_on_tbl['y'] = y
	-- ߖTW擾B
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x, y, 1, distance_from_factory+1);
	local i = 1
	while tbl_x[i] ~= nil do
		-- ߖTɑ݂郆jbg𒲂ׂB
		unit_status = ks_get_unit_status_on(tbl_x[i], tbl_y[i])
		if unit_status ~= nil then
			local uid = unit_status['id']
			if friendly_tbl[unit_status['side']] > 0 then
				-- wc܂͗FRȂAjbgޕʂɃCtŏWvB
				exist_tbl[uid] = exist_tbl[uid] + unit_status['life']
				-- wcȂAiډ\jbg]pjB
				if unit_status['side'] == my_side then
					load_sum_tbl[uid] = load_sum_tbl[uid] + 1
				end
			else
				-- GRȂAU͂ƃ_[WWvB
				table.foreach(cand_tbl,
					function(n,t)
--						print_log("uid="..uid.." t="..t)
						for gun=0,GUN_MAX-1,1 do
--							print_log("uid="..uid.." t="..t.." gun="..gun)
							atk_sum_tbl[t] = atk_sum_tbl[t] + unit_atk_tbl[t][gun][uid]
							if ks_is_neighbor(x, y, tbl_x[i], tbl_y[i], unit_info_tbl[uid]['guninfo'][gun]['maxrange']) then
								dmg_sum_tbl[t] = dmg_sum_tbl[t] + unit_atk_tbl[uid][gun][t]
							end
						end
					end
				)
			end
		end
		i = i+1
	end
	-- Y\jbg̕]߂B
	local total = 0;
	table.foreach(cand_tbl,
		function(key,uid)
			i = 0
			-- ͂̓Gɑ΂鋭B
			i = atk_sum_tbl[uid] - dmg_sum_tbl[uid]/2
			-- ̔\́B
			if unit_info_tbl[uid]['occupy'] then
				i = i + 50
			end
			-- ڔ\́B͂ɐ̉\{݂ZB
			if occupy_x == nil and unit_info_tbl[uid]['loadmax'] > 0 then
				i = i + eval_load_unit(uid, load_sum_tbl) * unit_info_tbl[uid]['loadmax']
			end
			-- GpB
			if tekisaku then
				if i == 0 and unit_info_tbl[uid]['visibility'] > 3 then
					i = 100
				end
			end
			-- |Cg̈ꕔړ͂̕]őB
			if is_indirect_unit(uid) then
				i = i*(1.0-eval_of_indirect_move) + i*unit_info_tbl[uid]['movemax']*eval_of_indirect_move/2
			else
				i = i*(1.0-eval_of_direct_move) + i*unit_info_tbl[uid]['movemax']*eval_of_direct_move/2
			end
			if tekisaku then
				i = i*(1.0-eval_of_visiblility) + i*unit_info_tbl[uid]['visibility']*eval_of_visibility/2
			end
			-- AɎ͂ɂ̂ȂA|Cg̔̑䐔ŉB
			if(exist_tbl[uid] > 0) then
				i = i/2 + ((i*100/2)/exist_tbl[uid])
			end
			need_on_tbl[uid] = i
			total = total + i
		end
	)
	-- ̒n_̃g[^]i[B
	need_on_tbl['total'] = total
	return need_on_tbl
end
-----------------------------------------------------------------------------
-- SY\n_ł̎vjbg𒲂ׂB
-- eY\n_ŁA͂̓Gjbg𒲂ׁAY\ȃjbgꂼɂ
-- v]^B
local function get_create_need_table(ground_layer)
	local x,y
	local my_side = ks_get_my_side()
	local friendly_tbl = side_info_tbl[my_side]['friendly'];
	local need_tbl = {}		-- ve[u
	local occupy_unit_id = com_util.get_occupy_unit_id()	-- ̉\jbgID
	local game_info = ks_get_game_information()
	local tekisaku = game_info['tekisaku']

	for y = 0,map_height-1,1 do
		for x = 0,map_width-1,1 do
			if not ks_get_unit_exists(x,y) then
				local need_on_tbl = get_create_need_table_on(x, y, my_side, friendly_tbl, ground_layer, occupy_unit_id, tekisaku)
				-- (x,y)n_̃jbgve[ui[B
				need_tbl[y*map_width + x] = need_on_tbl
			end
		end
	end
	return need_tbl
end
-----------------------------------------------------------------------------
-- tblval炻̃CfbNXԂB
local function table_find(tbl, val)
	local ret = -1
	table.foreach(tbl, function (k,v) if v==val then ret=k end end)
	return ret
end
-----------------------------------------------------------------------------
-- \Z budget ŕ]̍jbg𐶎YB
local function exec_create_on(my_side,need_on_tbl,budget)
	local x = need_on_tbl['x']
	local y = need_on_tbl['y']
	local cand_tbl = ks_get_creatable_unit_on(x,y,my_side)
	local uid = -1
	local max_eval = -100000000

	table.foreach(need_on_tbl,
		function(key,val)
--			print_log('key:'..key..' val:'..val)
			-- L[jbgIDłȂvf͖B
			if type(key) ~= 'number' then
				return
			end
			-- Ys\ȃjbg͖B
			if table_find(cand_tbl, key) == -1 then
				return
			end
--			print_log('  key:'..key..' val:'..val)
			-- ]jbgȂ`𒲂ׂB
			if max_eval < val then
				def_tbl = unit_info_tbl[key]
				-- \ZȂ猈B
				if def_tbl['value'] <= budget then
					max_eval = val
					uid = key
				end
			end
		end
	)
	if uid ~= -1 then
--		print_log('create:'..uid)
		ks_set_create(x,y,uid,true)
	end
	return uid
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_create = {}

com_default_create['set_eval_of_direct_attack'] = function(v) eval_of_direct_attack = v  end
com_default_create['set_eval_of_indirect_attack'] = function(v) eval_of_indirect_attack = v  end
com_default_create['set_eval_of_direct_move'] = function(v) eval_of_direct_move = v  end
com_default_create['set_eval_of_indirect_move'] = function(v) eval_of_indirect_move = v  end
com_default_create['set_eval_of_visibility'] = function(v) eval_of_visibility = v  end
com_default_create['set_distance_from_factory'] = function(v) distance_from_factory = v  end

com_default_create['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end
-----------------------------------------------------------------------------
-- YsB
com_default_create['create_units'] = function()
	local ground_layer = ks_get_ground_layer()
	local need_tbl = get_create_need_table(ground_layer)

	local need_sort_tbl = {}
	local count=1
	table.foreach(need_tbl,
		function(xy, v)
			need_sort_tbl[count] = xy
			count = count + 1
		end
	)

	-- Y\_𐶎Y]ō~\[gB
	table.sort(need_sort_tbl, function(xy1, xy2) return (need_tbl[xy1]['total'] > need_tbl[xy2]['total']) end)

	local my_side = ks_get_my_side()
	local money = side_info_tbl[my_side]['money']

	table.foreach(need_sort_tbl,
		function(n, xy)
			need_on_tbl = need_tbl[xy]
			local budget = money
			if budget > 3000 then
				budget = budget / 2
			end
			local uid = exec_create_on(my_side, need_on_tbl, budget)
			if uid ~= -1 then
				money = money - unit_info_tbl[uid]['value']
			end
		end
	)
end
-----------------------------------------------------------------------------
