-- sړ[`B

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local map_width,map_height = ks_get_mapsize()			-- }bvTCY

require('com_util.lua')

-- sTaB
local capital_search_radius = 24

local side_info_tbl = nil

-----------------------------------------------------------------------------
-- (x,y)ɍł߂sTB͒n`ɊւȂPȋߕB
local function find_enemy_capital(ground_layer, my_side, x, y, r)
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x,y,0,r)
	local count = table.getn(tbl_x)

	for i=1,count,1 do
		local gnd_tbl = ground_layer[tbl_y[i]*map_width + tbl_x[i]]
		if gnd_tbl['is_capital'] and gnd_tbl['owner'] ~= my_side and
			(gnd_tbl['owner'] == -1 or side_info_tbl[my_side]['friendly'][gnd_tbl['owner']] <= 0) then
			return tbl_x[i],tbl_y[i]
		end
	end
	return nil
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_goto_capital = {}

com_default_goto_capital['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end
-----------------------------------------------------------------------------
-- ߂̓GsڎwBUȂB߂l͈ړWB
com_default_goto_capital['action_unit_goto_enemy_capital'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	local px,py = find_enemy_capital(ground_layer, my_side, unit_state['x'], unit_state['y'], capital_search_radius)
	if px == nil then
		return
	end

	-- ̉\jbgłȂƂ̏B
	local dont_move_to_capital
	if not unit_info['occupy'] then
		-- I񂾓Gs̎͂ɁAwc̐̉\jbg邩ǂ`FbNB
		myside_tbl, enemy_tbl = com_util.get_neighbor_exists_unit_list(px, py, 3, side_info_tbl[my_side]['friendly'])
		local exists_my_occupy_unit=0
		table.foreach(myside_tbl,
			function(uid, lifetotal)
				if unit_info_tbl[uid]['occupy'] then
					exists_my_occupy_unit = exists_my_occupy_unit + lifetotal
				end
			end
		)
		-- ̂ȂA͎sɂ͓ȂB
		if exists_my_occupy_unit >= 100 then
			dont_move_to_capital=true
		end
	end

	-- Ȓ̈ړ\͈͂𒲂ׂB
	local movex, movey = com_util.get_way_xy(px, py, my_side, serial, unit_state['fuel'], dont_move_to_capital)

	return movex,movey
end
-----------------------------------------------------------------------------
