-- ̂̎vl[`B̉\ȃjbgȊOł̃[`ĂяoĂ܂Ӗ͂Ȃ낤B

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local ground_tbl = com_cached_db.get_ground_table()
local map_width,map_height = ks_get_mapsize()			-- }bvTCY

local side_info_tbl

-----------------------------------------------------------------------------
-- n`񂩂Ả\ǂfB
local function is_occupyable_ground(gnd_tbl, my_side)
	return ((gnd_tbl['is_building'] and gnd_tbl['owner'] ~= my_side) and
			(gnd_tbl['owner'] == -1 or side_info_tbl[my_side]['friendly'][gnd_tbl['owner']] <= 0))
end
-----------------------------------------------------------------------------
-- (x,y)ɍł߂̉\n`TB͎̈ړRXgŋ߂B
local function find_occupy_location(ground_layer, my_side, x, y, unit_state, cost)
	local movable_layer = ks_get_distance_layer(x, y, unit_state['id'], cost)
	local maxp=0
	local px, py

	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			local gnd_tbl = ground_layer[i]
			if is_occupyable_ground(gnd_tbl, my_side) then
				-- ȊO̖jbĝȂ΁AƂ肠B
				local unit_state2
				if x ~= unit_state['x'] or y ~= unit_state['y'] then
					unit_state2 = ks_get_unit_status_on(x, y)
				end
				if unit_state2 == nil or unit_state2['side'] ~= my_side then
					if maxp < p then
						maxp = p
						px = x
						py = y
					end
				end
			end
		end
	)
	return px,py
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_occupy = {}

com_default_occupy['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end
-----------------------------------------------------------------------------
-- ^[Ő̉\Ȓn`TA΂ԂB
com_default_occupy['action_unit_occupy_direct'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	-- ͈́i^[̈ړ\͈́jB
	local cost = math.min(unit_state['fuel'], unit_info['movemax'])

	local movable_layer = ks_get_distance_layer(unit_state['x'], unit_state['y'], unit_state['id'], cost)
	local movex, movey
	local maxp=0

	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			local gnd_tbl = ground_layer[i]
			if is_occupyable_ground(gnd_tbl, my_side) then
				-- ړ\Ȃ炻̍WԂB
				if ks_set_attack(my_side, serial, x, y, -1, 0, 0, false) then
					local p
					-- ꂪdv{݂ł΁AD悷B
					if gnd_tbl['is_capital'] then
						p = 3
					elseif gnd_tbl['is_creatable'] then
						p = 2
					else
						p = 1
					end
					if maxp < p then
						maxp = p
						movex = x
						movey = y
					end
				end
			end
		end
	)

	return movex, movey
end
-----------------------------------------------------------------------------
-- ̉\n`TAڎwB
com_default_occupy['action_unit_occupy'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	-- ͈͂B
	local cost = unit_state['fuel']/3
	if cost < unit_info['movemax']*2 then
		cost = unit_state['fuel']
	end

	-- ߂̐̉\n`TB
	local px, py = find_occupy_location(ground_layer, my_side, unit_state['x'], unit_state['y'], unit_state, cost)
	if px == nil then
		return
	end

	-- Ȓ̈ړ\͈͂𒲂ׂB
	local movex, movey = com_util.get_way_xy(px, py, my_side, serial, unit_state['fuel'])

	return movex, movey
end
