-- Ԃ̎vl[`B̃^[ňړďԉ\ȃjbgΏB
-- ̂ƂAQ^[ȏォēڃjbgǂ悤ȂƂ͂ȂB

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local map_width,map_height = ks_get_mapsize()			-- }bvTCY

require('com_util.lua')

local myside_layer, enemy_layer
-----------------------------------------------------------------------------
-- (ux,uy)ɍł߂hqvn`TB͎̈ړRXgŋ߂B
local function find_need_save_location(my_side, ux, uy, unit_state, cost)
	local movable_layer = ks_get_distance_layer(ux, uy, unit_state['id'], cost)
	local maxp=0
	local px, py
	local maxsavep=0

	table.foreach(movable_layer,
		function(i, p)
			if myside_layer[i] ~= nil then
				local x,y = ks_index2xy(i)
				local myside_tbl = myside_layer[i]
				local enemy_tbl = enemy_layer[i]
				local savep = 0
				table.foreach(myside_tbl,
					function(uid, life)
						savep = savep - life*com_util.eval_unit_value(unit_info_tbl[uid])
					end
				)
				table.foreach(enemy_tbl,
					function(uid, life)
						savep = savep + life*com_util.eval_unit_value(unit_info_tbl[uid])
					end
				)
				-- ߂̖hqv_ɍsB
				-- ̎Ƃhqv̍_Ăꍇ͖邱ƂɂȂ邪B
				if maxsavep < savep and maxp < p then
					maxp = p
					px = x
					py = y
				end
			end
		end
	)
	return px,py
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_save = {}

-----------------------------------------------------------------------------
com_default_save['init_on_phasestart'] = function()
	-- ŕς邩Ȃ͖B
	local ground_layer = ks_get_ground_layer()
	-- wcȂǁB
	local my_side = ks_get_my_side()
	local side_info_tbl = ks_get_side()
	local friendly_tbl = side_info_tbl[my_side]['friendly'];

	-- wcdv_ɂāA̖͂ƓGCtv߂B
	myside_layer = {}
	enemy_layer = {}
	for y = 0,map_height-1,1 do
		for x = 0,map_width-1,1 do
			local gnd = ground_layer[y*map_width + x]
			if gnd['owner'] == my_side then
				if gnd['is_capital'] or gnd['is_self_creatable'] then
					local myside_tbl, enemy_tbl = com_util.get_neighbor_exists_unit_list(x, y, 6, friendly_tbl)
					myside_layer[y*map_width + x] = myside_tbl
					enemy_layer[y*map_width + x] = enemy_tbl
				end
			end
		end
	end
end
-----------------------------------------------------------------------------
-- ݈ړł鏊ŖhqƎvꏊ΁ÄʒuԂB
com_default_save['action_unit_save'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

	-- ͈͂B
	local cost = unit_state['fuel']/3
	if cost < unit_info['movemax']*2 then
		cost = unit_state['fuel']
	end

	-- ߂̖hqvn`TB
	local px, py = find_need_save_location(my_side, unit_state['x'], unit_state['y'], unit_state, cost)
	if px == nil then
		return
	end

	-- Ȓ̈ړ\͈͂𒲂ׂB
	local movex, movey = com_util.get_way_xy(px, py, my_side, serial, unit_state['fuel'])

	return movex, movey
end
