void debugmode(mode)
{
    ks_debugmode(mode);
}

void set_script_step(step)
{
    ks_set_script_step(step);
}

void message(msg)
{
	ks_message(msg);
}

long window_show(title)
{
    long i;
    i = ks_window_show(title);
    halt;
    return i;
}

long window_hide()
{
    long i;
    i = ks_window_hide();
    halt;
    return i;
}

long window_size_get(*w,*h)
{
    return ks_window_size_get(w,h);
}

long window_size_set(w,h)
{
    long i;
    i = ks_window_size_set(w,h);
    halt;
    return i;
}

long window_wait_set(msec)
{
    return ks_window_wait_set(msec);
}

long window_wait()
{
    return ks_window_wait();
}

void window_wait_msec(msec)
{
    window_wait_set(msec);
    while(window_wait())
        halt;
}

long window_msg_out(msg)
{
    long i;
    i = ks_window_msg_out(msg);
    halt;
    return i;
}

long window_msg_clear()
{
    long i;
    i = ks_window_msg_clear();
    halt;
    return i;
}

long window_boxfill(x1,y1,x2,y2,c1,c2)
{
    return ks_window_boxfill(x1,y1,x2,y2,c1,c2);
}

long window_msg_view(x1,y1,x2,y2)
{
    return ks_window_msg_view(x1,y1,x2,y2);
}

long window_clear()
{
    long i;
    i = ks_window_clear();
    halt;
    return i;
}

long window_img_load(file)
{
	return ks_window_img_load(file);
}

long window_img_unload(num)
{
	return ks_window_img_unload(num);
}

long window_img_copy(dst,x,y,src,x1,y1,x2,y2)
{
    return ks_window_img_copy(dst,x,y,src,x1,y1,x2,y2);
}

long window_str(x,y,s,c1)
{
    return ks_window_str(x,y,s,c1);
}

long window_mouse_left_clicked()
{
    return ks_window_mouse_left_clicked();
}

long game_status_get(*array)
{
    return ks_game_status_get(array);
}

long unit_index2serial(side,index){
    return ks_unit_index2serial(side,index);
}

long unit_serial2index(side,serial){
    return ks_unit_serial2index(side,serial);
}

long unit_side_on(x,y)
{
    return ks_unit_side_on(x,y);
}

long unit_index_on(x,y)
{
    return ks_unit_index_on(x,y);
}

long unit_status_get(side,index, *array)
{
    return ks_unit_status_get(side, index, array);
}

long unit_append(x,y,side,id)
{
    return ks_unit_append(x,y,side,id);
}

long unit_remove(x,y)
{
    return ks_unit_remove(x,y);
}

long ground_status_get(x, y, *array)
{
    return ks_ground_status_get(x, y, array);
}

long ground_status_set(x, y, *array)
{
    return ks_ground_status_set(x, y, array);
}

long side_status_get(side, *array)
{
    return ks_side_status_get(side, array);
}

long side_relation_get(long side1, long side2, long *array)
{
    return ks_side_relation_get(side1,side2,array);
}

long side_relation_set(long side1, long side2, long *array)
{
    return ks_side_relation_set(side1,side2,array);
}

long var_set_int(str name, long var)
{
    return ks_var_set_int(name,var);
}

long var_set_str(str name, str var)
{
    return ks_var_set_str(name,var);
}

long var_get_int(str name)
{
    return ks_var_get_int(name);
}

void var_get_str(str name, str var)
{
    ks_var_get_str(name,var);
}

// ƃRpCG[ɂȂB
long main(){}
